function text_to_query_str(text_input_name, param_name) {
    if ($(text_input_name).val() == "") {
        return "";
    }

    var items = $(text_input_name).val().split(" ");

    return items.map( function(item) {
        if (item == "") {
            return "";
        }
        return "&" + param_name + "=" + item;
    } ).join("");
}

function create_people_filters() {
    var query_str = "";

    $( "#assignee_select option:selected" ).each(function() {
         query_str += "&assignee=" + $(this).text();
    });

    $( "#reporter_select option:selected" ).each(function() {
         query_str += "&reporter=" + $(this).text();
    });

    $( "#verifier_select option:selected" ).each(function() {
         query_str += "&verifier=" + $(this).text();
    });

    query_str += text_to_query_str("#assigned_person_select", "assigned_person");

    return query_str;
}

function go_to_url(base_url, assignee_str, tab_name) {
    var query_str = "";

    if ($("#milestone_select").length) {
        $( "#milestone_select option:selected" ).each(function() {
            query_str += "&milestone=" + $(this).text();
        });
    }

    $( "#status_select option:selected" ).each(function() {
        query_str += "&status=" + $(this).text();
    });

    $( "#importance_select option:selected" ).each(function() {
        query_str += "&importance=" + $(this).text();
    });

    query_str += text_to_query_str("#tags_select", "tags");

    query_str += text_to_query_str("#exclude_tags_select", "exclude_tags");

    var status = ["created", "fix_committed", "fix_released"];
    var border = ["_from", "_to"];

    var dates_filter = "";
    for (var i = 0; i < status.length; i++) {
        for (var j = 0; j < border.length; j++) {
            if ($("#date_"+status[i]+border[j]).val() != "") {
                dates_filter += "&"+status[i]+border[j]+"="+($("#date_"+status[i]+border[j])).val();
            }
        }
    }

    query_str += dates_filter;
    query_str += assignee_str;

    if (tab_name != "") {
        query_str += "&tab_name=" + tab_name;
    }

    query_str = query_str.substr(1, query_str.length);

    window.location.href = base_url + "?" + query_str;
}

function get_current_url() {
    var current_url = document.URL;
    if (current_url.indexOf("?")>-1) {
        current_url = current_url.substr(0, current_url.indexOf("?"));
    }
    return current_url
}

function apply_filters() {
    go_to_url(get_current_url(), create_people_filters(), "");
}

function get_csv() {
    var query_str = "&format=csv" + create_people_filters()

    go_to_url(get_current_url(), query_str, "");
}

function bind_search_key() {
    var search_btn = $('.searchform #apply-filters');

    if (!search_btn.length) {
        return false;
    }

    $('body').keypress(function(e) {
        var key = e.which;
        if (key === 13) {  //enter key code
            search_btn.click();
            return false;
        }
    });
}

$(document).ready(function() {
    bind_search_key();
});
